###重构订单状态逻辑的更新
- 执行以下sql：
    ALTER TABLE `bm_orders` 
    ADD COLUMN `cancel_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '取消订单时间' AFTER `receiving_time`;

- 线上.env添加如下配置
    DOCTER_WECHAT_APPID=wx6df68b725662f8a3
    DOCTER_MNWECHAT_APPID=wx1dcbf8ce4bca6870
    
----以上线上已更新----

###后台疫苗排班的更新
- 执行以下sql：
    ALTER TABLE `bm_vaccines` 
    ADD COLUMN `appoint_week_text` varchar(255) NOT NULL DEFAULT '不限' COMMENT '预约周的具体时间点描述' AFTER `states`;
    
    CREATE TABLE `bm_vaccine_appoints` (
      `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
      `vaccine_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '疫苗ID',
      `week_appoint` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '周的可接种的具体时间点',
      `created_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
      `updated_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
      PRIMARY KEY (`id`),
      KEY `vaccine_id` (`vaccine_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
    
    CREATE TABLE `bm_user_next_vaccines` (
      `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
      `user_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用户ID',
      `patient_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '患者ID',
      `vaccine_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '疫苗ID',
      `next_vaccinate_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下次接种时间',
      `is_vaccinate` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经接种(0.否 1.是)',
      `vaccinate_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接种时间',
      `created_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
      `updated_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
      PRIMARY KEY (`id`),
      KEY `user_id` (`user_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
    
    ALTER TABLE `bm_orders` 
    ADD COLUMN `is_source` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否占用号源(0.否 1.是)' AFTER `cancel_time`;

- 线上在社区端后台改消息通知的菜单链接为：/community/noticeManage/noticelist

----以上线上已更新----
